Package org.springframework.cglib.core

# Class ReflectUtils

java.lang.Object
org.springframework.cglib.core.ReflectUtils

public class ReflectUtils extends Object

## Method Summary

Modifier and Type
Method
Description
`static List`
`addAllInterfaces(Class type, List list)`
`static List`
`addAllMethods(Class type, List list)`
`static Class`
`defineClass(String className, byte[] b, ClassLoader loader)`
`static Class`
`defineClass(String className, byte[] b, ClassLoader loader, ProtectionDomain protectionDomain)`
`static Class`
`defineClass(String className, byte[] b, ClassLoader loader, ProtectionDomain protectionDomain, Class<?> contextClass)`
`static Constructor`
`findConstructor(String desc)`
`static Constructor`
`findConstructor(String desc, ClassLoader loader)`
`static Method`
`findDeclaredMethod(Class type, String methodName, Class[] parameterTypes)`
`static Method`
`findInterfaceMethod(Class iface)`
`static Method`
`findMethod(String desc)`
`static Method`
`findMethod(String desc, ClassLoader loader)`
`static Method[]`
`findMethods(String[] namesAndDescriptors, Method[] methods)`
`static Method`
`findNewInstance(Class iface)`
`static int`
`findPackageProtected(Class[] classes)`
`static PropertyDescriptor[]`
`getBeanGetters(Class type)`
`static PropertyDescriptor[]`
`getBeanProperties(Class type)`
`static PropertyDescriptor[]`
`getBeanSetters(Class type)`
`static Class[]`
`getClasses(Object[] objects)`
`static ClassInfo`
`getClassInfo(Class clazz)`
`static Constructor`
`getConstructor(Class type, Class[] parameterTypes)`
`static Type[]`
`getExceptionTypes(Member member)`
`static MethodInfo`
`getMethodInfo(Member member)`
`static MethodInfo`
`getMethodInfo(Member member, int modifiers)`
`static String[]`
`getNames(Class[] classes)`
`static Method[]`
`getPropertyMethods(PropertyDescriptor[] properties, boolean read, boolean write)`
`static ProtectionDomain`
`getProtectionDomain(Class source)`
`static Signature`
`getSignature(Member member)`
`static Class<?>`
`loadClass(String className, ClassLoader classLoader)`
`static Object`
`newInstance(Class type)`
`static Object`
`newInstance(Class type, Class[] parameterTypes, Object[] args)`
`static Object`
`newInstance(Constructor cstruct, Object[] args)`
`static void`
`setGeneratedClassHandler(BiConsumer<String,byte[]> handler)`
`static void`
`setLoadedClassHandler(Consumer<Class<?>> loadedClassHandler)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### getProtectionDomain

public static ProtectionDomain getProtectionDomain(Class source)

### getExceptionTypes

public static Type[] getExceptionTypes(Member member)

### getSignature

public static Signature getSignature(Member member)

### findConstructor

public static Constructor findConstructor(String desc)

### findConstructor

public static Constructor findConstructor(String desc, ClassLoader loader)

### findMethod

public static Method findMethod(String desc)

### findMethod

public static Method findMethod(String desc, ClassLoader loader)

### newInstance

public static Object newInstance(Class type)

### newInstance

public static Object newInstance(Class type, Class[] parameterTypes, Object[] args)

### newInstance

public static Object newInstance(Constructor cstruct, Object[] args)

### getConstructor

public static Constructor getConstructor(Class type, Class[] parameterTypes)

### getNames

public static String[] getNames(Class[] classes)

### getClasses

public static Class[] getClasses(Object[] objects)

### findNewInstance

public static Method findNewInstance(Class iface)

### getPropertyMethods

public static Method[] getPropertyMethods(PropertyDescriptor[] properties, boolean read, boolean write)

### getBeanProperties

public static PropertyDescriptor[] getBeanProperties(Class type)

### getBeanGetters

public static PropertyDescriptor[] getBeanGetters(Class type)

### getBeanSetters

public static PropertyDescriptor[] getBeanSetters(Class type)

### findDeclaredMethod

public static Method findDeclaredMethod(Class type, String methodName, Class[] parameterTypes) throws NoSuchMethodException

Throws:
  `NoSuchMethodException`

### addAllMethods

public static List addAllMethods(Class type, List list)

### addAllInterfaces

public static List addAllInterfaces(Class type, List list)

### findInterfaceMethod

public static Method findInterfaceMethod(Class iface)

### setGeneratedClassHandler

public static void setGeneratedClassHandler(BiConsumer<String,byte[]> handler)

### defineClass

public static Class defineClass(String className, byte[] b, ClassLoader loader) throws Exception

Throws:
  `Exception`

### defineClass

public static Class defineClass(String className, byte[] b, ClassLoader loader, ProtectionDomain protectionDomain) throws Exception

Throws:
  `Exception`

### defineClass

public static Class defineClass(String className, byte[] b, ClassLoader loader, ProtectionDomain protectionDomain, Class<?> contextClass) throws Exception

Throws:
  `Exception`

### setLoadedClassHandler

public static void setLoadedClassHandler(Consumer<Class<?>> loadedClassHandler)

### loadClass

public static Class<?> loadClass(String className, ClassLoader classLoader) throws ClassNotFoundException

Throws:
  `ClassNotFoundException`

### findPackageProtected

public static int findPackageProtected(Class[] classes)

### getMethodInfo

public static MethodInfo getMethodInfo(Member member, int modifiers)

### getMethodInfo

public static MethodInfo getMethodInfo(Member member)

### getClassInfo

public static ClassInfo getClassInfo(Class clazz)

### findMethods

public static Method[] findMethods(String[] namesAndDescriptors, Method[] methods)